diff -ruN strongswan-5.8.4/src/libstrongswan/utils/compat/windows.c strongswancont-5.8.4-svc/src/libstrongswan/utils/compat/windows.c
--- strongswan-5.8.4/src/libstrongswan/utils/compat/windows.c	2016-04-22 23:01:35.000000000 +0300
+++ strongswancont-5.8.4-svc/src/libstrongswan/utils/compat/windows.c	2022-12-05 16:24:40.188691000 +0300
@@ -16,9 +16,43 @@
 /* WSAPoll() */
 #define _WIN32_WINNT 0x0600
 
-#include <utils/utils.h>
+#include "windows.h"
+
+/**
+ * MT safe dlerror variant with caller supplied buffer
+ * See header
+ */
+char *dlerror_mt(char *buf, size_t buf_len)
+{
+	return human_readable_error(buf, GetLastError(), buf_len);
+}
+
+/**
+ * 
+ * MT safe variant that only performs GetLastError() for the supplied
+ * variable in the system error message catalogue
+ * See header.
+ */
+char *human_readable_error(char *buf, DWORD err, size_t buf_len)
+{
+	char *pos;
+
+	if (FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM | FORMAT_MESSAGE_IGNORE_INSERTS,
+					  NULL, err, 0, buf, buf_len, NULL) > 0)
+	{
+		pos = strchr(buf, '\n');
+		if (pos)
+		{
+			*pos = '\0';
+		}
+	}
+	else
+	{
+		snprintf(buf, buf_len, "(%u)", err);
+	}	
+	return buf;
+}
 
-#include <errno.h>
 
 /**
  * See header
diff -ruN strongswan-5.8.4/src/libstrongswan/utils/compat/windows.h strongswancont-5.8.4-svc/src/libstrongswan/utils/compat/windows.h
--- strongswan-5.8.4/src/libstrongswan/utils/compat/windows.h	2020-03-29 11:59:15.000000000 +0300
+++ strongswancont-5.8.4-svc/src/libstrongswan/utils/compat/windows.h	2022-07-08 13:24:01.735332000 +0300
@@ -21,12 +21,21 @@
 #ifndef WINDOWS_H_
 #define WINDOWS_H_
 
+#include <errno.h>
+
+/* Defined in order to be able to build the openssl plugin */
+#define NOCRYPT
+
 #include <winsock2.h>
+#include <devpropdef.h>
 #include <ws2tcpip.h>
 #include <direct.h>
 #include <inttypes.h>
 #include <unistd.h>
 #include <sys/stat.h>
+#include <setupapi.h>
+
+#include "unix.h"
 
 /* undef Windows variants evaluating values more than once */
 #undef min
@@ -39,6 +48,8 @@
 /* used by Windows API, but we have our own */
 #undef CALLBACK
 
+#include <utils/utils.h>
+
 /* UID/GID types for capabilities, even if not supported */
 typedef u_int uid_t;
 typedef u_int gid_t;
@@ -137,12 +148,12 @@
 /**
  * Provided by printf hook backend
  */
-int asprintf(char **strp, const char *fmt, ...);
+//int asprintf(char **strp, const char *fmt, ...);
 
 /**
  * Provided by printf hook backend
  */
-int vasprintf(char **strp, const char *fmt, va_list ap);
+//int vasprintf(char **strp, const char *fmt, va_list ap);
 
 /**
  * timeradd(3) from <sys/time.h>
@@ -263,6 +274,24 @@
 char* dlerror(void);
 
 /**
+ * thread save dlerror variant, uses caller supplied buffer
+ * @param  buf     caller supplied buffer
+ * @param  buf_len length of caller supplied buffer
+ * @return             caller supplied buffer
+ */
+char *dlerror_mt(char *buf, size_t buf_len);
+
+/**
+ * function for translating the given error into a human readable error message
+ * using FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM | FORMAT_MESSAGE_IGNORE_INSERTS, ...)
+ * @param  buf caller supplied buffer
+ * @param  err caller supplied erorr value to translate
+ * @param  buf_len length of caller supplied buffer
+ * @return             caller supplied buffer
+ */
+char *human_readable_error(char *buf, DWORD err, size_t buf_len);
+
+/**
  * dlclose() from <dlfcn.h>
  */
 int dlclose(void *handle);
@@ -278,6 +307,26 @@
 char* getpass(const char *prompt);
 #define HAVE_GETPASS
 
+WINSETUPAPI BOOL WINAPI SetupDiGetDeviceInterfacePropertyW(
+    HDEVINFO                  DeviceInfoSet,
+    PSP_DEVICE_INTERFACE_DATA DeviceInterfaceData,
+    const DEVPROPKEY          *PropertyKey,
+    DEVPROPTYPE               *PropertyType,
+    PBYTE                     PropertyBuffer,
+    DWORD                     PropertyBufferSize,
+    PDWORD                    RequiredSize,
+    DWORD                     Flags
+);
+
+WINAPI LSTATUS RegSetKeyValueA(
+    HKEY    hKey,
+    LPCSTR  lpSubKey,
+    LPCSTR  lpValueName,
+    DWORD   dwType,
+    LPCVOID lpData,
+    DWORD   cbData
+) __attribute__((dllimport));
+
 /**
  * Map MSG_DONTWAIT to the reserved, but deprecated MSG_INTERRUPT
  */
diff -ruN strongswan-5.8.4/src/libstrongswan/utils/debug.c strongswancont-5.8.4-svc/src/libstrongswan/utils/debug.c
--- strongswan-5.8.4/src/libstrongswan/utils/debug.c	2018-10-04 00:35:17.000000000 +0300
+++ strongswancont-5.8.4-svc/src/libstrongswan/utils/debug.c	2022-07-06 15:47:35.630997000 +0300
@@ -17,7 +17,7 @@
 
 #include "debug.h"
 
-ENUM(debug_names, DBG_DMN, DBG_ANY,
+ENUM(debug_names, DBG_DMN, DBG_CNT,
 	"DMN",
 	"MGR",
 	"IKE",
@@ -36,10 +36,11 @@
 	"APP",
 	"ESP",
 	"LIB",
-	"ANY",
+	"CNT",	
+	//"ANY",	
 );
 
-ENUM(debug_lower_names, DBG_DMN, DBG_ANY,
+ENUM(debug_lower_names, DBG_DMN, DBG_CNT,
 	"dmn",
 	"mgr",
 	"ike",
@@ -58,7 +59,8 @@
 	"app",
 	"esp",
 	"lib",
-	"any",
+	"cnt",
+	//"any",
 );
 
 /**
diff -ruN strongswan-5.8.4/src/libstrongswan/utils/debug.h strongswancont-5.8.4-svc/src/libstrongswan/utils/debug.h
--- strongswan-5.8.4/src/libstrongswan/utils/debug.h	2018-10-04 00:35:17.000000000 +0300
+++ strongswancont-5.8.4-svc/src/libstrongswan/utils/debug.h	2022-07-06 15:47:35.606997000 +0300
@@ -68,6 +68,8 @@
 	DBG_ESP,
 	/** libstrongswan */
 	DBG_LIB,
+	/** contact plugins */
+	DBG_CNT,	
 	/** number of groups */
 	DBG_MAX,
 	/** pseudo group with all groups */
diff -ruN strongswan-5.8.4/src/libstrongswan/utils/identification.c strongswancont-5.8.4-svc/src/libstrongswan/utils/identification.c
--- strongswan-5.8.4/src/libstrongswan/utils/identification.c	2019-08-29 12:55:35.000000000 +0300
+++ strongswancont-5.8.4-svc/src/libstrongswan/utils/identification.c	2023-05-07 14:24:37.762207000 +0300
@@ -66,26 +66,28 @@
 	{"ND", 					OID_NAME_DISTINGUISHER,		ASN1_PRINTABLESTRING},
 	{"UID", 				OID_PILOT_USERID,			ASN1_PRINTABLESTRING},
 	{"DC", 					OID_PILOT_DOMAIN_COMPONENT, ASN1_PRINTABLESTRING},
-	{"CN",					OID_COMMON_NAME,			ASN1_PRINTABLESTRING},
-	{"S", 					OID_SURNAME,				ASN1_PRINTABLESTRING},
+	{"CN",					OID_COMMON_NAME,			ASN1_UTF8STRING},
+	{"S", 					OID_SURNAME,				ASN1_UTF8STRING},
 	{"SN", 					OID_SERIAL_NUMBER,			ASN1_PRINTABLESTRING},
 	{"serialNumber", 		OID_SERIAL_NUMBER,			ASN1_PRINTABLESTRING},
 	{"C", 					OID_COUNTRY,				ASN1_PRINTABLESTRING},
-	{"L", 					OID_LOCALITY,				ASN1_PRINTABLESTRING},
-	{"ST",					OID_STATE_OR_PROVINCE,		ASN1_PRINTABLESTRING},
-	{"STREET",				OID_STREET_ADDRESS,			ASN1_PRINTABLESTRING},
-	{"O", 					OID_ORGANIZATION,			ASN1_PRINTABLESTRING},
-	{"OU", 					OID_ORGANIZATION_UNIT,		ASN1_PRINTABLESTRING},
-	{"T", 					OID_TITLE,					ASN1_PRINTABLESTRING},
-	{"D", 					OID_DESCRIPTION,			ASN1_PRINTABLESTRING},
+	{"L", 					OID_LOCALITY,				ASN1_UTF8STRING},
+	{"ST",					OID_STATE_OR_PROVINCE,		ASN1_UTF8STRING},
+	{"STREET",				OID_STREET_ADDRESS,			ASN1_UTF8STRING},
+	{"O", 					OID_ORGANIZATION,			ASN1_UTF8STRING},
+	{"OU", 					OID_ORGANIZATION_UNIT,		ASN1_UTF8STRING},
+	{"T", 					OID_TITLE,					ASN1_UTF8STRING},
+	{"D", 					OID_DESCRIPTION,			ASN1_UTF8STRING},
 	{"postalAddress",		OID_POSTAL_ADDRESS,			ASN1_PRINTABLESTRING},
 	{"postalCode",			OID_POSTAL_CODE,			ASN1_PRINTABLESTRING},
-	{"N", 					OID_NAME,					ASN1_PRINTABLESTRING},
-	{"G", 					OID_GIVEN_NAME,				ASN1_PRINTABLESTRING},
+	{"N", 					OID_NAME,					ASN1_UTF8STRING},
+	{"G", 					OID_GIVEN_NAME,				ASN1_UTF8STRING},
 	{"I", 					OID_INITIALS,				ASN1_PRINTABLESTRING},
 	{"dnQualifier", 		OID_DN_QUALIFIER,			ASN1_PRINTABLESTRING},
 	{"dmdName", 			OID_DMD_NAME,				ASN1_PRINTABLESTRING},
-	{"pseudonym", 			OID_PSEUDONYM,				ASN1_PRINTABLESTRING},
+	{"IdentityCard", 		OID_IDENTITY_CARD,			ASN1_PRINTABLESTRING},
+	{"Nick", 				OID_NICK,					ASN1_UTF8STRING},
+	{"pseudonym", 			OID_PSEUDONYM,				ASN1_UTF8STRING},
 	{"ID", 					OID_UNIQUE_IDENTIFIER,		ASN1_PRINTABLESTRING},
 	{"EN", 					OID_EMPLOYEE_NUMBER,		ASN1_PRINTABLESTRING},
 	{"employeeNumber",		OID_EMPLOYEE_NUMBER,		ASN1_PRINTABLESTRING},
@@ -96,7 +98,8 @@
 	{"unstructuredName",	OID_UNSTRUCTURED_NAME,		ASN1_IA5STRING},
 	{"UA",					OID_UNSTRUCTURED_ADDRESS,	ASN1_PRINTABLESTRING},
 	{"unstructuredAddress", OID_UNSTRUCTURED_ADDRESS,	ASN1_PRINTABLESTRING},
-	{"TCGID", 				OID_TCGID,					ASN1_PRINTABLESTRING}
+	{"TCGID", 				OID_TCGID,					ASN1_PRINTABLESTRING},
+	{"organizationId", 		OID_ORGANIZATION_ID,		ASN1_UTF8STRING}
 };
 
 /**
@@ -222,10 +225,12 @@
 		{OID_COUNTRY,			ID_PART_RDN_C},
 		{OID_LOCALITY,			ID_PART_RDN_L},
 		{OID_STATE_OR_PROVINCE,	ID_PART_RDN_ST},
+		{OID_STREET_ADDRESS, 	ID_PART_RDN_STR},
 		{OID_ORGANIZATION,		ID_PART_RDN_O},
 		{OID_ORGANIZATION_UNIT,	ID_PART_RDN_OU},
 		{OID_TITLE,				ID_PART_RDN_T},
 		{OID_DESCRIPTION,		ID_PART_RDN_D},
+		{OID_POSTAL_CODE,		ID_PART_RDN_PC},
 		{OID_NAME,				ID_PART_RDN_N},
 		{OID_GIVEN_NAME,		ID_PART_RDN_G},
 		{OID_INITIALS,			ID_PART_RDN_I},
@@ -235,6 +240,8 @@
 		{OID_UNIQUE_IDENTIFIER,	ID_PART_RDN_ID},
 		{OID_EMAIL_ADDRESS,		ID_PART_RDN_E},
 		{OID_EMPLOYEE_NUMBER,	ID_PART_RDN_EN},
+		{OID_IDENTITY_CARD,		ID_PART_RDN_IC},
+		{OID_NICK,				ID_PART_RDN_NICK},
 	};
 
 	VA_ARGS_VGET(args, type, data);
@@ -1353,6 +1360,7 @@
 			break;
 		case ID_FQDN:
 		case ID_RFC822_ADDR:
+		case ID_DER_ASN1_GN_URI:
 			this->public.hash = _hash_binary;
 			this->public.equals = _equals_strcasecmp;
 			this->public.matches = _matches_string;
@@ -1416,6 +1424,7 @@
 		{ "asn1gn:",		ID_DER_ASN1_GN			},
 		{ "xmppaddr:",		ID_DER_ASN1_GN          },
 		{ "keyid:",			ID_KEY_ID				},
+		{ "uri:",			ID_DER_ASN1_GN_URI		},
 	};
 	private_identification_t *this;
 	int i;
diff -ruN strongswan-5.8.4/src/libstrongswan/utils/identification.h strongswancont-5.8.4-svc/src/libstrongswan/utils/identification.h
--- strongswan-5.8.4/src/libstrongswan/utils/identification.h	2020-03-29 11:59:15.000000000 +0300
+++ strongswancont-5.8.4-svc/src/libstrongswan/utils/identification.h	2022-07-06 15:47:35.630997000 +0300
@@ -190,6 +190,14 @@
 	ID_PART_RDN_ST,
 	/** Title RDN of a DN */
 	ID_PART_RDN_T,
+	/** Addres in state */
+	ID_PART_RDN_STR,
+	/** Postal code */
+	ID_PART_RDN_PC,
+	/** Identitu Card */
+	ID_PART_RDN_IC,
+	/** Nick */
+	ID_PART_RDN_NICK,
 };
 
 /**
diff -ruN strongswan-5.8.4/src/libstrongswan/utils/utils/object.h strongswancont-5.8.4-svc/src/libstrongswan/utils/utils/object.h
--- strongswan-5.8.4/src/libstrongswan/utils/utils/object.h	2018-10-04 00:35:17.000000000 +0300
+++ strongswancont-5.8.4-svc/src/libstrongswan/utils/utils/object.h	2022-07-06 15:47:35.606997000 +0300
@@ -123,4 +123,15 @@
 	static typeof(_cb_##name) *name = (typeof(_cb_##name)*)_cb_##name; \
 	static ret _cb_##name(param1, ##__VA_ARGS__)
 
+/**
+ * Same as CALLBACK(), but for two void* arguments (e.g. for comparisons).
+ */
+#define CALLBACK2(name, ret, param1, param2, ...) \
+   static ret _cb_##name(union {void *_generic; param1;} \
+   __attribute__((transparent_union)), \
+   union {void *_generic; param2;} \
+   __attribute__((transparent_union)), ##__VA_ARGS__); \
+   static typeof(_cb_##name) *name = (typeof(_cb_##name)*)_cb_##name; \
+   static ret _cb_##name(param1, param2, ##__VA_ARGS__)
+
 #endif /** OBJECT_H_ @} */
diff -ruN strongswan-5.8.4/src/libstrongswan/utils/utils/string.c strongswancont-5.8.4-svc/src/libstrongswan/utils/utils/string.c
--- strongswan-5.8.4/src/libstrongswan/utils/utils/string.c	2018-10-04 00:35:17.000000000 +0300
+++ strongswancont-5.8.4-svc/src/libstrongswan/utils/utils/string.c	2022-07-08 11:57:41.645254000 +0300
@@ -15,6 +15,7 @@
  */
 
 #include <utils/utils.h>
+#include <utils/utils/memory.h>
 
 /**
  * Described in header.
@@ -89,3 +90,31 @@
 	strcpy(dst, pos);
 	return res;
 }
+
+linked_list_t *strsplit(const char *str, const char *tokstr)
+{
+	linked_list_t *list = linked_list_create();
+	size_t str_len = strlen(str);
+	char *saveptr, *tok = NULL, *copy = alloca(str_len+1), *tok_cpy;
+	memcpy(copy, str, str_len);
+	tok = strtok_r(copy, tokstr, &saveptr);
+	if (tok) {
+	    	tok_cpy = malloc(strlen(tok)+1);
+		memcpy(tok_cpy, tok, strlen(tok)+1);
+		list->insert_last(list, tok_cpy);
+		while (TRUE)
+		{
+			tok = strtok_r(NULL, tokstr, &saveptr);
+			if (tok)
+			{
+				size_t substring_length = strlen(tok);
+				char *substring_copy = malloc(substring_length+1);
+				memcpy(substring_copy, tok,  substring_length+1);
+				list->insert_last(list, substring_copy);
+			} else {
+				break;
+			}
+		}
+	} 
+	return list;
+}
diff -ruN strongswan-5.8.4/src/libstrongswan/utils/utils/string.h strongswancont-5.8.4-svc/src/libstrongswan/utils/utils/string.h
--- strongswan-5.8.4/src/libstrongswan/utils/utils/string.h	2018-10-04 00:35:17.000000000 +0300
+++ strongswancont-5.8.4-svc/src/libstrongswan/utils/utils/string.h	2022-07-08 11:58:55.978930000 +0300
@@ -22,6 +22,8 @@
 #ifndef STRING_H_
 #define STRING_H_
 
+#include "../../collections/linked_list.h"
+
 /**
  * Helper function that compares two strings for equality
  */
@@ -100,4 +102,14 @@
  */
 char *strreplace(const char *str, const char *search, const char *replace);
 
+/**
+ * Splits the string into tokens seperated by the given substring
+ * Returns a linked list containing the strings, allocated on the heap.
+ * 
+ * @param str           original string
+ * @param tokstr        String to split the original string with
+ * @return              linked list containing the strings
+ */
+linked_list_t *strsplit(const char *str, const char *tokstr);
+
 #endif /** STRING_H_ @} */
diff -ruN strongswan-5.8.4/src/libstrongswan/utils/utils/time.c strongswancont-5.8.4-svc/src/libstrongswan/utils/utils/time.c
--- strongswan-5.8.4/src/libstrongswan/utils/utils/time.c	2018-10-04 00:35:17.000000000 +0300
+++ strongswancont-5.8.4-svc/src/libstrongswan/utils/utils/time.c	2022-07-06 15:47:35.602997000 +0300
@@ -52,7 +52,7 @@
 	 * monotonic time source only if it is also supported by pthread. */
 	timespec_t ts;
 
-	if (clock_gettime(CLOCK_MONOTONIC, &ts) == 0)
+	if (clock_gettime(TIME_CLOCK_ID, &ts) == 0)
 	{
 		if (tv)
 		{
diff -ruN strongswan-5.8.4/src/libstrongswan/utils/utils/time.h strongswancont-5.8.4-svc/src/libstrongswan/utils/utils/time.h
--- strongswan-5.8.4/src/libstrongswan/utils/utils/time.h	2018-10-04 00:35:17.000000000 +0300
+++ strongswancont-5.8.4-svc/src/libstrongswan/utils/utils/time.h	2022-07-06 15:47:35.630997000 +0300
@@ -33,6 +33,20 @@
 #define TIME_32_BIT_SIGNED_MAX	0x7fffffff
 
 /**
+ * The clock that should be used for time_monotonic() and conditional variables
+ */
+#ifdef HAVE_CLOCK_GETTIME
+#ifdef HAVE_CONDATTR_CLOCK_MONOTONIC
+/* only can use different clocks if we can set it via attribute */
+#ifndef TIME_CLOCK_ID
+#define TIME_CLOCK_ID CLOCK_MONOTONIC
+#endif
+#else
+#define TIME_CLOCK_ID CLOCK_MONOTONIC
+#endif
+#endif
+
+/**
  * Handle struct timeval like an own type.
  */
 typedef struct timeval timeval_t;
diff -ruN strongswan-5.8.4/src/libstrongswan/utils/windows_helper.c strongswancont-5.8.4-svc/src/libstrongswan/utils/windows_helper.c
--- strongswan-5.8.4/src/libstrongswan/utils/windows_helper.c	1970-01-01 03:00:00.000000000 +0300
+++ strongswancont-5.8.4-svc/src/libstrongswan/utils/windows_helper.c	2022-12-08 11:18:00.148410000 +0300
@@ -0,0 +1,386 @@
+/*
+ * Copyright (C) 2020 Noel Kuntze
+ *
+ * This program is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by the
+ * Free Software Foundation; either version 2 of the License, or (at your
+ * option) any later version.  See <http://www.fsf.org/copyleft/gpl.txt>.
+ *
+ * This program is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
+ * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * for more details.
+ */
+
+#include "windows_helper.h"
+
+/**
+ * See header
+ */
+bool guid2string(char *dst, size_t dst_len, const GUID *guid, bool braces)
+{
+	size_t ret = 0;
+	char *with_braces = "{%08lx-%04x-%04x-%02x%02x-%02x%02x%02x%02x%02x%02x}",
+		*without_braces = "%08lx-%04x-%04x-%02x%02x-%02x%02x%02x%02x%02x%02x";
+	if (braces)
+	{
+		if (dst_len >= 39 )
+		{
+		ret = snprintf(dst, dst_len,
+			with_braces,
+			guid->Data1, guid->Data2, guid->Data3,	
+			guid->Data4[0], guid->Data4[1], guid->Data4[2], guid->Data4[3],
+			guid->Data4[4], guid->Data4[5], guid->Data4[6], guid->Data4[7]);			
+		}
+		else
+		{
+			DBG0(DBG_LIB, "Buffer too small!");
+		}
+	}
+	else
+	{
+		if (dst_len >= 37)
+		{
+		ret = snprintf(dst, dst_len,
+			without_braces,
+			guid->Data1, guid->Data2, guid->Data3,	
+			guid->Data4[0], guid->Data4[1], guid->Data4[2], guid->Data4[3],
+			guid->Data4[4], guid->Data4[5], guid->Data4[6], guid->Data4[7]);
+		}
+		else {
+			DBG0(DBG_LIB, "Buffer too small!");
+		}
+	}
+	return ret >= 36 ? TRUE : FALSE;
+}
+
+bool guidfromstring(GUID *guid, const char *str, bool with_braces)
+{
+	char *format = with_braces ?
+				   "{%08lX-%04hX-%04hX-%02hhX%02hhX-%02hhX%02hhX%02hhX%02hhX%02hhX%02hhX}%n" :
+				   "%08lX-%04hX-%04hX-%02hhX%02hhX-%02hhX%02hhX%02hhX%02hhX%02hhX%02hhX%n";
+	size_t nchars = 0;
+	size_t nfields = sscanf_s(str, format,
+		&guid->Data1, &guid->Data2, &guid->Data3,	
+		&guid->Data4[0], &guid->Data4[1], &guid->Data4[2], &guid->Data4[3],
+		&guid->Data4[4], &guid->Data4[5], &guid->Data4[6], &guid->Data4[7], &nchars);
+	if (nfields == 11 && ((with_braces && nchars == 38) || (!with_braces && nchars == 36)))
+	{
+		return TRUE;
+	}
+	return FALSE;
+}
+
+/**
+ * see header
+ */
+bool registry_wait_get_value(HKEY key, void *caller_buf, DWORD *caller_buf_len,
+							 char *reg_val_name, DWORD *reg_val_type, size_t timeout)
+{
+	/* timeout is in ms */
+	timeval_t now, deadline;
+	DWORD own_ret = FALSE, function_ret_query, function_ret_wait;
+	char buf[512];
+
+	HANDLE handle = CreateEventA(NULL, FALSE, FALSE, NULL);
+	if (!handle)
+	{
+		char buf[512];
+		dlerror_mt(buf, sizeof(buf));
+		DBG1(DBG_LIB, "Failed to create handle: %s", buf);
+		return FALSE;
+	}
+	/* Get current time, add timeout */
+	time_monotonic(&deadline);
+	timeval_add_ms(&deadline, timeout);
+
+	while(TRUE)
+	{
+		/* Try to get value */
+		function_ret_query = RegQueryValueExA(key, reg_val_name, NULL, reg_val_type, caller_buf, (LPDWORD) caller_buf_len);
+		time_monotonic(&now);
+		int64_t ms_to_deadline = (deadline.tv_sec - now.tv_sec) * 1000 + (deadline.tv_usec - now.tv_usec);
+		switch(function_ret_query)
+		{
+			case ERROR_FILE_NOT_FOUND:
+			case ERROR_PATH_NOT_FOUND:
+				/* All vars in this calculation are signed, so no issues
+				 * until the first part overflows (certainly farther in the future than this code will run)
+				 */				
+				if (ms_to_deadline <= 0)
+				{
+					DBG1(DBG_LIB, "Timed out waiting for registry value %s", reg_val_name);
+					goto out;
+					break;
+				}
+				/* Set up handle for notify */
+				if (RegNotifyChangeKeyValue(key, FALSE, REG_NOTIFY_CHANGE_LAST_SET, handle, true) != ERROR_SUCCESS)
+				{
+					dlerror_mt(buf, sizeof(buf));
+					DBG1(DBG_LIB, "Failed to call RegNotifyChangeKeyValue: %s", buf);
+					goto out;
+					break;
+				}
+				function_ret_wait = WaitForSingleObjectEx(handle, ms_to_deadline, FALSE);
+				if(function_ret_wait && function_ret_wait != WAIT_OBJECT_0 )
+				{
+					dlerror_mt(buf, sizeof(buf));
+					DBG1(DBG_LIB, "Failed to wait for event (WaitForSingleObjectEx(): %ld): %s", function_ret_wait, buf);
+					goto out;
+					break;
+				}
+				break;
+			case ERROR_MORE_DATA:
+				caller_buf = realloc(caller_buf, *caller_buf_len);
+				break;
+			case ERROR_SUCCESS:
+			case TRUE:
+				/* succeeded */
+				own_ret = TRUE;
+				goto out;
+				break;
+			case ERROR_INVALID_HANDLE:
+				DBG1(DBG_LIB, "Invalid handle. Failed to read string.");
+				goto out;
+				break;
+			default:
+				dlerror_mt(buf, sizeof(buf));
+				DBG1(DBG_LIB, "Failed to read registry value (RegQueryValueExA): %s", buf);
+				goto out;
+				break;
+		}
+	}
+	out:
+	CloseHandle(handle);
+	return own_ret;
+}
+
+/**
+ * Described in header.
+ */
+char *windows_expand_string(char *buf, DWORD *buf_len, size_t *new_buf_len)
+{
+	size_t new_length = *buf_len, required_size;
+	char *intermediate_buf = NULL;
+
+	for(size_t i=0;i<=2;i++)
+	{
+		intermediate_buf = realloc(intermediate_buf, new_length);
+		required_size = ExpandEnvironmentStringsA(buf, intermediate_buf, new_length);
+		if (required_size > new_length)
+		{
+			new_length = required_size;
+		}
+		else
+		{
+			break;
+		}
+	}
+	*new_buf_len = new_length;
+	return intermediate_buf;
+}
+
+/**
+ * Described in header.
+ */
+HKEY registry_open_wait(HKEY key, char *path, DWORD access, size_t timeout)
+{
+	/* timeout is in ms */
+	HKEY intermediate = NULL;
+	size_t path_len = strlen(path) + 1, ret;
+	char buf[512], *str = path, *tok, *current_path = alloca(path_len),
+		*current_path_cpy = alloca(path_len), *last_part;
+	bool first = TRUE;
+	timeval_t now, deadline;
+	DWORD function_ret_wait;
+	/* Number of iterations */
+
+	// linked_list_t *tokens = strsplit_race(path, "\\");
+	linked_list_t *tokens = strsplit(path, "\\,");
+	tokens->get_last(tokens, (void **) &last_part);
+	enumerator_t *enumerator = tokens->create_enumerator(tokens);
+	
+	HANDLE handle = CreateEventA(NULL, FALSE, FALSE, NULL);
+	if (!handle)
+	{
+		char buf[512];
+		dlerror_mt(buf, sizeof(buf));
+		DBG1(DBG_LIB, "Failed to create handle: %s", buf);
+		return FALSE;
+	}
+
+	/* Get current time, add timeout */
+	time_monotonic(&deadline);
+	timeval_add_ms(&deadline, timeout);	
+	
+	/* In the loop, we check if each key occuring in the path is accessible.
+	 * If a key is not, it will be created by the installation routine
+	 * that was called before this function.
+	 * This means that we instead wait for an event in the registry in
+	 * which the key was created.
+	 */
+	while (enumerator->enumerate(enumerator, &tok))
+	{
+		if (tok)
+		{
+			if (first)
+			{
+				memcpy(current_path, tok, strlen(tok)+1);
+				first = FALSE;
+			}
+			else
+			{
+				memcpy(current_path_cpy, current_path, path_len);
+				snprintf(current_path, path_len, "%s\\%s", current_path_cpy, tok);			
+			}
+			/* Add the new token to the path*/
+			/* Check if the current path is accessible */
+			if (last_part == tok)
+			{
+				access = KEY_NOTIFY;
+			}
+			
+			switch((ret=RegOpenKeyA(key, current_path, &intermediate)))
+			{
+				case true:
+				case ERROR_SUCCESS:
+					break;
+				case ERROR_FILE_NOT_FOUND:
+				case ERROR_PATH_NOT_FOUND:
+					time_monotonic(&now);
+					/* All vars in this calculation are signed, so no issues
+					 * until the first part overflows (certainly farther in the future than this code will run)
+					 */
+					int64_t ms_to_deadline = (deadline.tv_sec - now.tv_sec) * 1000 + (deadline.tv_usec - now.tv_usec);
+					if (ms_to_deadline <= 0)
+					{
+						DBG1(DBG_LIB, "Timed out waiting for registry value %s", current_path);
+						break;
+						break;
+					}
+					/* Setup notifier */
+					if ((function_ret_wait=RegNotifyChangeKeyValue(key, FALSE, REG_NOTIFY_CHANGE_NAME, handle, true)))
+					{
+						DBG1(DBG_LIB, "Failed to setup notify handle for REG_NOTIFY_CHANGE_NAME on %s using RegNotifyChangeKeyValue: %s",
+							current_path, human_readable_error(buf, function_ret_wait, sizeof(buf)));
+						goto cleanup;
+					}
+					/* Check if we can access the key */
+					switch((ret = RegOpenKeyExA(key, current_path, 0, access, &intermediate)))
+					{
+						case true:
+						case ERROR_SUCCESS:
+							/* Close the notifier handle again and open a new one, just in case the kernel handles reusing of active handles badly.*/
+							CloseHandle(handle);
+							handle = CreateEventA(NULL, FALSE, FALSE, NULL);							
+							if (!handle)
+							{
+								dlerror_mt(buf, sizeof(buf));
+								DBG1(DBG_LIB, "Failed to create handle: %s", buf);
+							}
+							break;
+						case ERROR_FILE_NOT_FOUND:
+						case ERROR_PATH_NOT_FOUND:
+							time_monotonic(&now);
+							/* All vars in this calculation are signed, so no issues
+							 * until the first part overflows (certainly farther in the future than this code will run)
+							 */
+							int64_t ms_to_deadline = (deadline.tv_sec - now.tv_sec) * 1000 + (deadline.tv_usec - now.tv_usec);
+							if (ms_to_deadline <= 0)
+							{
+								DBG1(DBG_LIB, "Timed out waiting for registry value %s", current_path);
+								goto cleanup;
+							}
+							function_ret_wait = WaitForSingleObjectEx(handle, ms_to_deadline, FALSE);
+							switch(function_ret_wait)
+							{
+								case WAIT_OBJECT_0:
+									break;
+								case WAIT_TIMEOUT:
+									DBG1(DBG_LIB, "Failed to wait for event (WaitForSingleObjectEx() for path %s: %ld): The time limit (timeout) was reached", current_path, function_ret_wait);
+									break;
+								case WAIT_FAILED:
+									DBG1(DBG_LIB, "Failed to wait for event (WaitForSingleObjectEx() for path %s: %ld): %s", function_ret_wait, current_path, dlerror_mt(buf, sizeof(buf)));
+									break;
+							}
+							if(function_ret_wait != WAIT_OBJECT_0)
+							{
+								goto cleanup;
+							}
+							break;
+						default:
+							dlerror_mt(buf, sizeof(buf));
+							DBG1(DBG_LIB, "Failed to open registry value (RegOpenKeyEx): (decimal %u) %s", ret, buf);
+							goto cleanup;
+							break;
+					}
+					break;
+				default:
+					dlerror_mt(buf, sizeof(buf));
+					DBG1(DBG_LIB, "Failed to open registry key %s (RegOpenKeyA): (decimal %u) %s", current_path, ret, buf);
+					goto cleanup;
+					break;
+			}
+		}
+	}
+
+cleanup: ;
+	tokens->reset_enumerator(tokens, enumerator);
+	while(enumerator->enumerate(enumerator, &str))
+	{
+		free(str);
+	}
+	enumerator->destroy(enumerator);
+	tokens->destroy(tokens);
+	CloseHandle(handle);
+	return intermediate;
+}
+
+bool check_reboot(HDEVINFO dev_info_set, SP_DEVINFO_DATA *dev_info_data)
+{
+	SP_DEVINSTALL_PARAMS dev_install_params = {
+		.cbSize = sizeof(SP_DEVINSTALL_PARAMS)
+	};
+	bool ret = SetupDiGetDeviceInstallParamsA(dev_info_set, dev_info_data, &dev_install_params);
+	return dev_install_params.Flags & (DI_NEEDREBOOT | DI_NEEDRESTART) & ret;
+}
+
+/**
+ * If dst_len is 0, the buffer is allocated on the heap using malloc()
+ * @param dst
+ * @param dst_len
+ * @param str
+ * @param str_len
+ * @return 
+ */
+int ascii2utf16(LPWSTR *dst, size_t dst_len, const char *str, const size_t str_len)
+{
+	int ret = dst_len;
+	for(int i=0;i<2;i++)
+	{
+	ret = MultiByteToWideChar(CP_ACP, 0, str, str_len, *dst, ret);
+	if(!ret)
+	{
+		char buf[512];
+		DBG1(DBG_LIB, "Failed to convert string (ascii2utf) with dst %p, dst_len %u, str %p and str_Len %u: %u",
+			dst, dst_len, str, str_len, dlerror_mt(buf, sizeof(buf)));
+		return 0;
+	}
+	*dst = malloc(ret*sizeof(WCHAR));
+	if(!(*dst))
+	{
+		DBG1(DBG_LIB, "Failed to convert string (ascii2utf) with dst %p, dst_len %u, str %p and str_Len %u because the required memory of %u byte could not be allocated.",
+			dst, dst_len, str, str_len, ret);
+		return 0;
+	}
+	}
+	return ret;
+}
+
+/**
+ * See header.
+ */
+bool handle_is_valid(HKEY handle)
+{
+	return (handle != NULL && (long long) handle > 1);
+}
\ В конце файла нет новой строки
